#include "Arduino.h"
#include "gapchecker.h"

int targetBoxNum;
int curBoxNum;

bool beforeLastIsGap;
bool lastIsGap;
float lastCheckTime;

void InitChecker(int boxNum){
    Serial.println((String)"InitChecker: " + boxNum);
    targetBoxNum = boxNum;
    curBoxNum = 0;
    lastIsGap = true;
    beforeLastIsGap = true;
    lastCheckTime = 0;
}

int GetCheckerValue(){
    int value = analogRead(Checker);
    Serial.println(value);
    return value;
}

bool IsTargetReached(){
    float now = millis() / 1000.0;
    // 如果监测间隔小于0.05s则直接不检测，返回false
    if(now - lastCheckTime < 0.05) return false;
    bool nowIsGap = GetCheckerValue() > MinGapValue;
    if(nowIsGap && lastIsGap && (!beforeLastIsGap)){
        // 第一次不是，且其后连续两次为Gap，box数加1
        curBoxNum++;
        Serial.println((String)"boxNum:"+curBoxNum);
    }
    beforeLastIsGap = lastIsGap;
    lastIsGap = nowIsGap;
    return curBoxNum >= targetBoxNum;
}